﻿//NameHKScriptMenu::Unlock>Rearrange>Lock
#target Illustrator
var doc = app.activeDocument;
var ll = [];
function unlockLayers(l) {
	for (var i = 0; i < l.length; i++) {
        if (l[i].locked) {
			ll.push(l[i]);
            l[i].locked = false;
        };
        if (l[i].layers.length) unlockLayers(l[i].layers);
    };
	return ll;
};
var lockedLayers = unlockLayers(doc.layers);
app.executeMenuCommand('unlockAll');
redraw();
var lockedObjects = doc.selection;
for ( i = 0; i < lockedObjects.length; i++ ) {
	tag = lockedObjects[i].tags.add();
	tag.name = "LockedObject";
};
app.executeMenuCommand('ReArrange Artboards')
var n = doc.tags.length;
while (n--) {
	if (doc.tags[n].name == "LockedObject") {
		doc.tags[n].parent.locked = true;
		doc.tags[n].remove();
	};
};
var l = lockedLayers.length;
while (l--) lockedLayers[l].locked = true;